<?php

namespace Aimeos\MShop\Order\Item;

class CustomOrderItem extends Standard
{
    public function __construct(string $prefix, array $values = [])
    {
        parent::__construct($prefix, $values);
    }

    public function getOrderNo(): ?string
    {
        return $this->get('order.order_no');
    }

    public function setOrderNo(?string $val): \Aimeos\MShop\Order\Item\Iface
    {
        return $this->set('order.order_no', $val);
    }

    public function fromArray(array &$list, bool $private = false): \Aimeos\MShop\Order\Item\Iface
    {
        $item = parent::fromArray($list, $private);

        foreach ($list as $key => $value) {
            switch ($key) {
                case 'order.order_no':
                    $item = $item->setOrderNo($value);
                    break;
                default:
                    continue 2;
            }
            unset($list[$key]);
        }

        return $item;
    }

    public function toArray(bool $private = false): array
    {
        $list = parent::toArray($private);

        if ($private === true) {
            $list['order.order_no'] = $this->getOrderNo();
        }

        return $list;
    }
}
